SystemOrganization addCategory: #'SourceCity-Core'!

Object subclass: #AbstractCityComponent
	instanceVariableNames: 'name dimension color position dependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!AbstractCityComponent commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 16:00'!
absolutePosition
	^ self subclassResponsibility! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:24'!
addDependencies: anObject
	self dependencies add: anObject.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ color! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color: anObject
	color := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:23'!
dependencies
	^ dependencies! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:23'!
dependencies: anObject
	dependencies := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 11:20'!
dimension

	^ dimension! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 11:20'!
dimension: anObject

	dimension := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:23'!
initialize
	dependencies := #().! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 8/2/2012 15:34'!
isBuilding
	^false! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 8/2/2012 15:34'!
isCity
	^false! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 8/2/2012 15:34'!
isDistrict
	^false! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/11/2012 20:40'!
name
	^name asString! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/4/2012 13:08'!
name: anObject
	name := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
position

	^ position! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
position: anObject

	position := anObject! !

AbstractCityComponent subclass: #Building
	instanceVariableNames: 'district'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building class methodsFor: 'instance creation' stamp: 'DouailleErwan 8/30/2012 15:52'!
named: aName inDistrict: aDistrict dimension: a3Ddimension color: aColor dependencies: aCollection

	^ self new 
		name: aName;
		dimension: a3Ddimension;
		district: aDistrict;
		color: aColor;
		dependencies: aCollection;
		yourself.! !

!Building methodsFor: 'accessing' stamp: 'blo 7/5/2012 16:01'!
absolutePosition
	^ self position + self district absolutePosition! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
district
	^ district! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 7/10/2012 15:27'!
district: anObject
	district := anObject.
	district add: self.! !

!Building methodsFor: 'initialize' stamp: 'DouailleErwan 8/30/2012 15:09'!
initialize 
	super initialize.
	dependencies := Collection new.! !

!Building methodsFor: 'initialize' stamp: 'DouailleErwan 8/2/2012 15:34'!
isBuilding
	^true.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 7/23/2012 14:37'!
printOn: aStream

	"district ifNotNil: [ aStream
		nextPutAll: district asString; 
		nextPutAll: ' -> ']."
	name ifNotNil: [ aStream 
		nextPutAll: ' Building: '; 
		nextPutAll: self name ].! !

AbstractCityComponent subclass: #City
	instanceVariableNames: 'districts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City class methodsFor: 'instance creation' stamp: 'blo 7/4/2012 15:16'!
named: aName
	^ self new 
		name: aName.
		! !

!City methodsFor: 'accessing' stamp: 'blo 7/5/2012 16:01'!
absolutePosition
	^ self position! !

!City methodsFor: 'adding' stamp: 'blo 7/5/2012 12:33'!
add: aDistrict

	districts add: aDistrict.
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ Color r: 0.6 g: 0.6 b: 0.6! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts
	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'comparing' stamp: 'DouailleErwan 6/12/2012 10:22'!
hasDistrictNamed: aString

	^ districts anySatisfy: [ :each | each model name = aString ]! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:22'!
initialize

	super initialize.
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 8/2/2012 15:34'!
isCity
	^true.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 7/11/2012 20:29'!
printOn: aStream

	name ifNotNil: [ aStream 
		nextPutAll: ' City: '; 
		nextPutAll: self name].! !

AbstractCityComponent subclass: #District
	instanceVariableNames: 'buildings city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District class methodsFor: 'instance creation' stamp: 'DouailleErwan 8/30/2012 15:52'!
named: aName inCity: aCity

	^ self new
		name: aName;
		city: aCity;
		yourself .! !

!District methodsFor: 'adding' stamp: 'blo 7/8/2012 13:47'!
absolutePosition
	^ self position + self city absolutePosition! !

!District methodsFor: 'adding' stamp: 'blo 7/5/2012 12:34'!
add: aBuilding

	buildings add: aBuilding.
	^ aBuilding.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings
	^ buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings: anObject
	buildings := anObject! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
city
	^ city! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/10/2012 15:27'!
city: anObject
	city := anObject.
	city add: self.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:30'!
color
	^Color r: 0.8 g: 0.8 b:0.8! !

!District methodsFor: 'comparing' stamp: 'DouailleErwan 6/15/2012 12:38'!
hasBuildingNamed: aString

	^ buildings anySatisfy: [ :each | each model name = aString ]! !

!District methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/12/2012 14:52'!
initialize 
	
	super initialize.
	buildings := OrderedCollection new.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 8/2/2012 15:35'!
isDistrict
	^true.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/23/2012 14:37'!
printOn: aStream

"	city ifNotNil: [ aStream
		nextPutAll: city asString;
		nextPutAll: '-> ']."
	name ifNotNil: [ aStream 
		nextPutAll: ' District: '; 
		nextPutAll: self name].! !

Object subclass: #ManifestSourceCityCore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 13:25'!
rejectClasses
^ #()! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 13:25'!
rejectRules
^ #()! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:26'!
ruleClassNotReferencedRuleV1FalsePositive
^ #(#(#(#RGClassDefinition #(#SourceCityFactory)) #'2012-08-30T14:26:31.024+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:51'!
ruleExcessiveArgumentsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'Building class' #named:inDistrict:dimension:color:dependencies: #true)) #'2012-08-30T14:51:02.705+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:21'!
ruleImplementedNotSentRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#District #isDistrict #false)) #'2012-08-30T14:16:48.282+02:00') #(#(#RGMethodDefinition #(#District #buildings: #false)) #'2012-08-30T14:17:02.98+02:00') #(#(#RGMethodDefinition #(#AbstractCityComponent #isDistrict #false)) #'2012-08-30T14:17:47.337+02:00') #(#(#RGMethodDefinition #(#AbstractCityComponent #addDependencies: #false)) #'2012-08-30T14:18:05.04+02:00') #(#(#RGMethodDefinition #(#City #hasDistrictNamed: #false)) #'2012-08-30T14:21:06.576+02:00') #(#(#RGMethodDefinition #(#City #districts: #false)) #'2012-08-30T14:21:08.192+02:00') #(#(#RGMethodDefinition #(#City #isCity #false)) #'2012-08-30T14:21:12.54+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:17'!
ruleImplementedNotSentRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#District #hasBuildingNamed: #false)) #'2012-08-30T14:17:16.173+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:52'!
ruleInconsistentMethodClassificationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#City #printOn: #false)) #'2012-08-30T14:51:58.777+02:00') #(#(#RGMethodDefinition #(#City #absolutePosition #false)) #'2012-08-30T14:51:58.777000001+02:00') #(#(#RGMethodDefinition #(#District #printOn: #false)) #'2012-08-30T14:52:40.013+02:00') #(#(#RGMethodDefinition #(#District #initialize #false)) #'2012-08-30T14:52:40.013000001+02:00') #(#(#RGMethodDefinition #(#District #absolutePosition #false)) #'2012-08-30T14:52:40.013000002+02:00') #(#(#RGMethodDefinition #(#AbstractCityComponent #name #false)) #'2012-08-30T14:52:44.357+02:00') #(#(#RGMethodDefinition #(#Building #initialize #false)) #'2012-08-30T14:52:44.357000001+02:00') #(#(#RGMethodDefinition #(#AbstractCityComponent #absolutePosition #false)) #'2012-08-30T14:52:44.357000002+02:00') #(#(#RGMethodDefinition #(#Building #printOn: #false)) #'2012-08-30T14:52:44.357000003+02:00') #(#(#RGMethodDefinition #(#Building #isBuilding #false)) #'2012-08-30T14:52:44.357000004+02:00') #(#(#RGMethodDefinition #(#AbstractCityComponent #isBuilding #false)) #'2012-08-30T14:52:44.357000005+02:00') #(#(#RGMethodDefinition #(#AbstractCityComponent #initialize #false)) #'2012-08-30T14:52:44.357000006+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:09'!
ruleMissingSuperSendsRuleV1TODO
^ #()! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:09'!
ruleMissingSuperSendsRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#Building #initialize #false)) #'2012-08-30T15:09:53.592+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:52'!
ruleMissingYourselfRuleV1TODO
^ #()! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:52'!
ruleMissingYourselfRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#'District class' #named:inCity: #true)) #'2012-08-30T15:52:13.157+02:00') #(#(#RGMethodDefinition #(#'Building class' #named:inDistrict:dimension:color:dependencies: #true)) #'2012-08-30T15:52:21.979+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:08'!
ruleOnlyReadOrWrittenTemporaryRuleV1TODO
^ #()! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:08'!
ruleOnlyReadOrWrittenTemporaryRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#'SourceCityFactory class' #createCity:named:strategy: #true)) #'2012-08-30T15:08:39.422+02:00') )! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:29'!
ruleUnclassifiedMethodsRuleV1TODO
^ #()! !

!ManifestSourceCityCore class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 15:29'!
ruleUnclassifiedMethodsRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#'SourceCityFactory class' #createCity:named:strategy: #true)) #'2012-08-30T15:29:23.12+02:00') #(#(#RGMethodDefinition #(#'SourceCityFactory class' #createDistrict:city:strategy: #true)) #'2012-08-30T15:29:23.237+02:00') #(#(#RGMethodDefinition #(#City #absolutePosition #false)) #'2012-08-30T15:29:23.272+02:00') #(#(#RGMethodDefinition #(#'SourceCityFactory class' #createBuilding:district:strategy: #true)) #'2012-08-30T15:29:23.691+02:00') )! !

Object subclass: #SourceCityFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!SourceCityFactory commentStamp: '<historical>' prior: 0!
I do all the creation context of the city. Create all districts, buildings, caluclate each height ....!

!SourceCityFactory class methodsFor: 'initialize-release' stamp: 'DouailleErwan 7/12/2012 12:10'!
createBuilding: anObject district: aDistrict strategy: aStrategy
	^ Building named: (aStrategy buildingNameGenerator value: anObject)
		inDistrict: aDistrict 
		dimension: (aStrategy normalizedBuildingDimension value: anObject)
		color: (aStrategy normalizedColor value: anObject )
		dependencies: (aStrategy dependenciesSelector value: anObject ).
	! !

!SourceCityFactory class methodsFor: 'initialize-release' stamp: 'DouailleErwan 8/30/2012 15:08'!
createCity: anObject named: aName strategy: aStrategy
	| districtObjects city |
	districtObjects := aStrategy districtsSelector value: anObject.
	city := City named: aName.
	districtObjects do: [:district | 
		self createDistrict: district city: city strategy: aStrategy
		] displayingProgress: [:aDistrict | 'City creation'].
	^city.! !

!SourceCityFactory class methodsFor: 'initialize-release' stamp: 'DouailleErwan 7/10/2012 15:26'!
createDistrict: anObject city: aCity strategy: aStrategy
	| district |
	district := District named: (aStrategy districtNameGenerator value: anObject) inCity: aCity.
	(aStrategy buildingsSelector value: anObject) do: [:building |
		self createBuilding: building district: district strategy: aStrategy 
		].
	^district
	! !

!Float methodsFor: '*SourceCity-Core' stamp: 'DouailleErwan 7/10/2012 15:16'!
roundedUp
	"Return a rounded up"
	self sign = 1
	ifTrue:  [^self truncated + self sign rounded.].
	self sign = 0
	ifTrue: [^self truncated].
	self sign = -1
	ifTrue:  [^self sign rounded.].! !
